precision highp float;

varying vec2 TextureCoordsVarying;

/*
uniform sampler2D SrcTexture;
uniform sampler2D DstTexture;
uniform int BlendMode;
*/
/*图层*/
uniform sampler2D Texture0;
uniform sampler2D Texture1;
uniform sampler2D Texture2;
uniform sampler2D Texture3;
uniform sampler2D Texture4;
uniform sampler2D Texture5;
uniform sampler2D Texture6;
uniform sampler2D Texture7;
uniform sampler2D Texture8;
uniform sampler2D Texture9;
uniform sampler2D Texture10;
uniform sampler2D Texture11;
uniform sampler2D Texture12;
uniform sampler2D Texture13;
uniform sampler2D Texture14;
uniform sampler2D Texture15;
/*混合模式*/
uniform int BlendMode0;
uniform int BlendMode1;
uniform int BlendMode2;
uniform int BlendMode3;
uniform int BlendMode4;
uniform int BlendMode5;
uniform int BlendMode6;
uniform int BlendMode7;
uniform int BlendMode8;
uniform int BlendMode9;
uniform int BlendMode10;
uniform int BlendMode11;
uniform int BlendMode12;
uniform int BlendMode13;
uniform int BlendMode14;
uniform int BlendMode15;
/*一次性混合图层数量*/
uniform int BlendCount;

vec4 blendSrc(vec4 S, vec4 D, int Mode) {
    vec4 T = S;
    if (Mode <= 0) { //normal
        T = S + D * (1.0 - S.a);
    }
    else if (Mode == 2) { //screen
        T = 1.0 - (1.0 - D) * (1.0 - S);
    }
    else if (Mode == 3) { //overlay
        //        T = S * (1.0 - D.a) + D;

        T = 2.0 * S * D;
        if (S.r < 0.5) {
            T.r = 1.0 - 2.0 * (1.0 - S.r) * (1.0 - D.r);
        }
        if (S.g < 0.5) {
            T.g = 1.0 - 2.0 * (1.0 - S.g) * (1.0 - D.g);
        }
        if (S.b < 0.5) {
            T.b = 1.0 - 2.0 * (1.0 - S.b) * (1.0 - D.b);
        }
        if (S.a < 0.5) {
            T.a = 1.0 - 2.0 * (1.0 - S.a) * (1.0 - D.a);
        }
    }
    else if (Mode == 1 || Mode == 4) { //darken multiply
        T.a = S.a + D.a - S.a * D.a;
        T.rgb = (1.0 - D.a) * S.rgb + (1.0 - S.a) * D.rgb + min(S.rgb, D.rgb);
    }
    else if (Mode == 5) { //lighten
        T = max(D, S);
    }
    else if (Mode == 6) { //clear
        T = vec4(0.0);
    }
    else if (Mode == 7) { //copy
        T = S;
    }
    else if (Mode == 8) { //sourceIn
        T = S * D.a;
    }
    else if (Mode == 9) { //sourceOut
        T = S * (1.0 - D.a);
    }
    else if (Mode == 10) { //sourceAtop
        T = S * D.a + D * (1.0 - S.a);
    }
    else if (Mode == 11) { //destinationOver
        T = S * (1.0 - D.a) + D;
    }
    else if (Mode == 12) { //destinationIn
        T = D * S.a;
    }
    else if (Mode == 13) { //destinationOut
        T = D * (1.0 - S.a);
    }
    else if (Mode == 14) { //destinationAtop
        T = S * (1.0 - D.a) + D * S.a;
    }
    else if (Mode == 15) { //xor
        T = S * (1.0 - D.a) + D * (1.0 - S.a);
    }
    else if (Mode == 16) { //plusDarker
        T = max(vec4(0.0), S + D - 1.0);
    }
    else if (Mode == 17) { //plusLighter
        T = min(vec4(1.0), S + D);
    }

    return T;
}


vec4 getColorAtIndex(int index) {
    if (index == 0) {
        return texture2D(Texture0, TextureCoordsVarying);
    }
    else if (index == 1) {
        return texture2D(Texture1, TextureCoordsVarying);
    }
    else if (index == 2) {
        return texture2D(Texture2, TextureCoordsVarying);
    }
    else if (index == 3) {
        return texture2D(Texture3, TextureCoordsVarying);
    }
    else if (index == 4) {
        return texture2D(Texture4, TextureCoordsVarying);
    }
    else if (index == 5) {
        return texture2D(Texture5, TextureCoordsVarying);
    }
    else if (index == 6) {
        return texture2D(Texture6, TextureCoordsVarying);
    }
    else if (index == 7) {
        return texture2D(Texture7, TextureCoordsVarying);
    }
    else if (index == 8) {
        return texture2D(Texture8, TextureCoordsVarying);
    }
    else if (index == 9) {
        return texture2D(Texture9, TextureCoordsVarying);
    }
    else if (index == 10) {
        return texture2D(Texture10, TextureCoordsVarying);
    }
    else if (index == 11) {
        return texture2D(Texture11, TextureCoordsVarying);
    }
    else if (index == 12) {
        return texture2D(Texture12, TextureCoordsVarying);
    }
    else if (index == 13) {
        return texture2D(Texture13, TextureCoordsVarying);
    }
    else if (index == 14) {
        return texture2D(Texture14, TextureCoordsVarying);
    }
    else {
        return texture2D(Texture15, TextureCoordsVarying);
    }
}

int getBlendModeAtIndex(int index) {
    if (index == 0) {
        return BlendMode0;
    }
    else if (index == 1) {
        return BlendMode1;
    }
    else if (index == 2) {
        return BlendMode2;
    }
    else if (index == 3) {
        return BlendMode3;
    }
    else if (index == 4) {
        return BlendMode4;
    }
    else if (index == 5) {
        return BlendMode5;
    }
    else if (index == 6) {
        return BlendMode6;
    }
    else if (index == 7) {
        return BlendMode7;
    }
    else if (index == 8) {
        return BlendMode8;
    }
    else if (index == 9) {
        return BlendMode9;
    }
    else if (index == 10) {
        return BlendMode10;
    }
    else if (index == 11) {
        return BlendMode11;
    }
    else if (index == 12) {
        return BlendMode12;
    }
    else if (index == 13) {
        return BlendMode13;
    }
    else if (index == 14) {
        return BlendMode14;
    }
    else if (index == 15) {
        return BlendMode15;
    }

    return 0;
}


vec4 blendDstAtIndex(int index) {
    vec4 restColor = getColorAtIndex(0);
    for (int i = 1; i < index; i++) {
        vec4 srcColor = getColorAtIndex(i);
        vec4 dstColor = restColor;
        int mode = getBlendModeAtIndex(i);
        restColor = blendSrc(srcColor, dstColor, mode);
    }
    return restColor;
}


void main (void) {
    /*
    vec4 srcColor = texture2D(SrcTexture, TextureCoordsVarying);
    vec4 dstColor = texture2D(DstTexture, TextureCoordsVarying);

    gl_FragColor = blendSrc(srcColor, dstColor);
     */
    gl_FragColor = blendDstAtIndex(BlendCount);
}
